Subject: Serious Problems

From: "Michael Paesold" <[email-masked]>
Date: Tue, 6 Jun 2000 18:23:39 +0200

Hi!

Since I have read the recent discussion about netatalk in production
environments I was confident that using netatalk would be a good choice,
also in the long run.

Now I have run into serious troubles here at my site that point to serious
bugs in the netatalk code:

1) It appears that sometimes documents stored on the server (especially
saved on the server) get corrupted in some way: with some files copied back
to the mac, norton disk doctor (5.0) reports major problems, that can only
be corrected by replacing the files with original ones. (But where to take
originals from ?? :( )

2) There are often problems with files, that can be opened with an app (e.g.
quark xpress), can be saved, can be copied or moved on the server, but when
you try to copy them to the macintosh, the operation will be canceled with
error number -39.

3) The most serious incident was that one:
One user copied some files to a different location, than trashed a folder.
Afterwards, he was unable to empty the trash, so he wanted to move the
folder out of the trash again -> not possible. Then he tried to move some
other files to the trash when suddenly the hole content of the parent folder
disappeared. The trash can was empty now.
The hole files were deleted. (Later, I couldn't find them on the server
either)

The only thing I found was that two macs were connected with the same
user/passwd at the same time, nothing else.
The permission of all these files on the server volume are 660 owned by one
user and group users. The server runs SuSE Linux 6.4/Kernel 2.2.14. netatalk
version is netatalk-1.4b2+asun2.1.3 (SuSE default installation)

Perhaps someone has encountered similar problems. I will very happy with any
help.

Mike

--
Michael Paesold - mailto:[email-masked]
Vienna, Austria, Europe

---

From: Dejan Muhamedagic <[email-masked]>
Date: Tue, 6 Jun 2000 20:35:57 +0200

Hello,

>From the backup :)  I can't recall that this kind of thing has
been reported.  Also, if possible, can you be more specific (what
kind of files or all kinds, any messages in logs, etc)?

> you try to copy them to the macintosh, the operation will be canceled with

Some apps (qxp is one I think) keep files locked even after
closing them.  Did you try to exit from the application and then
do the copy?  I can't recall that people have had this problem.

> user/passwd at the same time, nothing else.

The Trash application needs some fiddling in order to get it to
work.  It also depends on the netatalk's version.  However, I'd
suggest that your users stay away from it, if possible.

> version is netatalk-1.4b2+asun2.1.3 (SuSE default installation)

I believe that there are many people still using successfully
netatalk 2.1.3, but I'd suggest moving to version 2.1.4-37b.  It's
a prerelease but pretty stable.  This one you'll have to compile
by yourself.  Check out the archive--there are many messages with
instructions and, after all, it's not difficult to do it.  If you
don't run any database apps (or similar which need byte-level
locking) then compile with -DUSE_FLOCK_LOCKS (put the def in
sys/linux/Makefile).

Another thing: many problems are bound to a particular application
running on the Mac.  The most notorious is definitely QXP.  It
would be helpful if you include information about this as well.
And anything reported through syslog.

Best regards,

Dejan

---

From: "Michael Paesold" <[email-masked]>
Date: Wed, 7 Jun 2000 12:24:22 +0200

> kind of files or all kinds, any messages in logs, etc)?

The backup is done on the server, so the backuped files are corrupted, too.
The
only solution is to open the files with the app and save them to a new file.
This thing mostly happens with qxp.

> do the copy?  I can't recall that people have had this problem.

Last night I restarted netatalk services, and the macs where
shutdown/restarted.
I tried to change permissions and to touch the file from shell (also the
corresponding .AppleDouble/* files). No result.

>From <http://til.info.apple.com/techinfo.nsf/artnum/n9805>:
-39   eofErr          End of file; no additional data in the format

> suggest that your users stay away from it, if possible.

But how to delete files?

> locking) then compile with -DUSE_FLOCK_LOCKS (put the def in

I'm thinking about that, but before I start to do it, I want to find
out more about possible error sources.

> And anything reported through syslog.

The workflow heavily depends on Quark XPress. So this could be
a main source of some of the problems.

Greetings,
Michael

--
Michael Paesold mailto:[email-masked]
Vienna, Austria, Europe

---

From: Dejan Muhamedagic <[email-masked]>
Date: Wed, 7 Jun 2000 14:11:46 +0200

Hello,

> This thing mostly happens with qxp.

If I got it right, qxp can open the file from the shared volume,
but, if you copy it to the mac then it's unusable.  And if you
open it with the qxp and do "Save as" to a local disk then it's
ok.  Right?  This is a long shot, but could it be that there has
been an end-of-line translation performed during the copy
operation?  Did you try to compare the good file with the
corrupted one?  Does copy "corrupt" all files?

> -39   eofErr          End of file; no additional data in the format

So, no application has been running on Mac and still Copy
produced this error?  That is strange.  I have to say that I can't
think of anything in specific.  Did you check the network for
errors (ifconfig, counters on the switch if you're using one)?
Does this error occur regardless of the transport used (tcp or ddp)?

> > suggest that your users stay away from it, if possible.

oops :)  It depends on the netatalk version.  With 2.1.4-3x the
trash won't work and users will get a warning that their files
will be deleted for good.  With 2.1.3 the situation is different
and there has been at a time a lengthy explanation how to set up
the trash.  IIRC, it was something like creating Trash Can
directories for all known users in advance.  Check the archive on
this.  On another hand, perhaps setting restrictive permissions on
the "Network Trash Folder" may stop users from using it.  I have
no experience with 2.1.3 so I can't give more advice here.

Good luck.

Dejan

---

From: "Michael Paesold" <[email-masked]>
Date: Wed, 7 Jun 2000 14:58:17 +0200

Dejan Muhamedagic <[email-masked]> wrote:

> > The backup is done on the server, so the backuped files are corrupted,
> > too. The only solution is to open the files with the app and save them
> > to a new file. This thing mostly happens with qxp.
>

No, it doesn't corrupt all files nor does it corrupt the files all the time,
so this ist really strange. The end-of-line translation could be the
problem.
I think samba doesn't do that at all. And I think this is the best way. I
find it ridiculous, that a file service should be made to _actively_change_
data that it transmits. Of course, sometimes this is quite fine, but there
are too many error sources.
When I recompile netatalk I will try to deactivate -CRLF translation
completely.

> Does this error occur regardless of the transport used (tcp or ddp)?

The strange thing is, that it only happens with some files, but I have
not been able to produce such damaged files intentionally.

> no experience with 2.1.3 so I can't give more advice here.

Since I am using 2.1.3 the trash can worked from the beginning,
but Thomas Riewe sent me advice how to deactivate the trash can
by making it unwriteable.

The hole thing with netatalk is really bad. Unlike samba, there is
only bad documentation and the hole thing is stuck in beta. I myself
have little to no experience in unix programming (especially networking)
but if the project is going to be revived, I am going to help
writing good docs for it.

Greetings,
Michael

Vienna, Austria

---

From: R Cent <[email-masked]>
Date: Wed, 7 Jun 2000 11:01:43 -0700 (PDT)

I was exploring my /var/log/messages file and found numerous
occurances resembling the entry shown below.  Can someone
describe what is happening?  Presumably they are contacts
originating from the .95 subnet, I don't have users in the .95
subnet.  Are these messages benign or not?  Thanks.

Jun  7 07:58:44 fuchslab atalkd[624]: zip ignoring gnireply
Jun  7 07:58:44 fuchslab atalkd[624]: zip gnireply from 95.250
(eth0 b2)
Jun  7 07:58:44 fuchslab atalkd[624]: zip ignoring gnireply
Jun  7 07:58:44 fuchslab atalkd[624]: zip gnireply from 95.252
(eth0 b2)
Jun  7 07:58:44 fuchslab atalkd[624]: zip ignoring gnireply
Jun  7 07:58:44 fuchslab atalkd[624]: zip gnireply from 95.194
(eth0 b2)
Jun  7 07:58:44 fuchslab atalkd[624]: zip ignoring gnireply
Jun  7 07:58:44 fuchslab atalkd[624]: zip gnireply from 95.150
(eth0 b2)
Jun  7 07:58:44 fuchslab atalkd[624]: zip ignoring gnireply 

_____________________________
Bob Cent 
University of Washington
Box 357330
Seattle, WA  98195-7330  

mailto: [email-masked]
voice:  206.543.1433
fax:    206.685.0305
_____________________________

---

From: andrew morgan <[email-masked]>
Date: Wed, 7 Jun 2000 11:43:25 -0700 (PDT)

> Jun  7 07:58:44 fuchslab atalkd[624]: zip ignoring gnireply 

We used to get these all the time from our macs.  The problem went away
when we reinstalled the macs, but it came back eventually.  I got tired of
the messages cluttering up my logs and patched the netatalk source to only
log these messages at a higher debug level.  The messages seem to be
benign.

	Andy

---

From: Patrik Schindler <[email-masked]>
Date: Thu, 8 Jun 2000 18:05:09 +0200

>locking) then compile with -DUSE_FLOCK_LOCKS (put the def in

Hm, from the users side I found that many applications which worked perfectly with 2.1.3 now break with 2.1.4-37b:

- Excel 3.0 (no I have my reasons why not to update)
- Quark XPress
- FreeHand (from a friend)
possibly others.

:wq! PoC

---

From: Patrik Schindler <[email-masked]>
Date: Thu, 8 Jun 2000 18:29:45 +0200

>subnet.  Are these messages benign or not?  Thanks.

This means only that an AppleTalk device asked for the network configuration and some routers responded to this request. Your atalkd saw these and states that they will be ignored.

:wq! PoC